<template>
  <div class="DateTimePicker">
    <label v-if="label" :for="uuid" class="InputField__Label">
      {{ label }}
    </label>
    <!--suppress HtmlUnknownTag -->
    <DatePicker
      v-model="value"
      :input-debounce="debounceDelay"
      :isDark="isDark"
      :locale="locale"
      :minute-increment="minuteIncrement"
      :timezone="timeZone"
      :mode="mode"
      is-required
      is24hr
      :update-on-input="false"
    >
      <template v-slot="{ inputValue, inputEvents, showPopover, hidePopover }">
        <!--suppress HtmlFormInputWithoutLabel -->
        <input
          :id="uuid"
          :placeholder="placeholder || label"
          :size="sizes[mode]"
          :value="inputValue"
          class="DateTimePicker__Input"
          @change="inputEvents.change"
          @focusin="
            (...args) => {
              if (mode !== 'time') showPopover(...args)
            }
          "
          @focusout="hidePopover"
          @input="inputEvents.input"
          @keyup="inputEvents.keyup"
        />
      </template>
    </DatePicker>
  </div>
</template>

<script lang="ts">
import { defineComponent } from 'vue'
import {
  CONTROL_DEBOUNCE_DELAY,
  ControlEmits,
  isControl,
} from '@/components/controls/mixins'
import { DatePicker } from 'v-calendar'
import moment from 'moment-timezone'

export default defineComponent({
  name: 'DateTimePicker',
  emits: [...ControlEmits, 'close', 'remove'],
  components: {
    DatePicker,
  },
  props: {
    mode: {
      type: String,
      default: 'dateTime',
    },
    label: String,
    placeholder: String,
    locale: String,
    modelValue: Date,
    minuteIncrement: {
      type: Number,
      default: 5,
    },
    timeZone: {
      type: String,
      required: true,
    },
    isDark: Boolean,
    debounceDelay: {
      type: Number,
      default: CONTROL_DEBOUNCE_DELAY,
    },
  },

  setup(props, context) {
    return {
      ...isControl<Date>({
        props,
        context,
        processValue: (value) => {
          if (!value) return props.modelValue
          const utcValue = moment(value).tz(props.timeZone)
          const utcModel = moment(props.modelValue).tz(props.timeZone)
          if (props.mode === 'date')
            return utcModel
              .year(utcValue.year())
              .month(utcValue.month())
              .date(utcValue.date())
              .toDate()
          if (props.mode === 'time')
            return utcModel
              .hour(utcValue.hour())
              .minute(utcValue.minute())
              .second(utcValue.second())
              .toDate()
          return moment(value).utc().toDate()
        },
      }),
      sizes: {
        time: '4',
        date: '10',
        datetime: '15',
      },
    }
  },
})
</script>

<style lang="scss">
@use '../../style/variables' as v;
@use 'sass:math';

.DateTimePicker {
  &__Input {
    display: inline-flex;
    width: auto;
    padding: v.$spacing-4 v.$spacing-2;
    border: none;
    background-color: transparent;
    color: var(--text-color);
    text-align: center;
  }
}
</style>
